using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using InstrumentDrivers;

namespace RSSMU_AWGN_Example
{
    public partial class RSSMU_AWGN_Example : Form
    {
        private rssmu m_Instrument = null;

        public RSSMU_AWGN_Example()
        {
            InitializeComponent();
        }

        private void RSSMU_AWGN_Example_Load(object sender, EventArgs e)
        {
            Mode.SelectedIndex = 0;
        }

        private void ExitButton_Click(object sender, EventArgs e)
        {
            if (MessageBox.Show("Are you sure you want to exit?", "Exit?", MessageBoxButtons.YesNo) == DialogResult.Yes)
                Close();
        }

        private void Apply_Click(object sender, EventArgs e)
        {
            rssmu instrument;
            int path = 1;
            try
            {
                UseWaitCursor = true;
                System.Windows.Forms.Cursor.Current = Cursors.WaitCursor;
                if (m_Instrument == null)
                    m_Instrument = new rssmu(ResourceDescriptor.Text, IDQuery.Checked, ResetDevice.Checked);
                m_Instrument.SetDMAcctoStandard(path, rssmuConstants.DmDigitalStandardW3gpp);
                m_Instrument.SetDMState(path, CustomDMState.Checked);
                m_Instrument.SetAWGNSystemBandwidth(path, Decimal.ToDouble(SystemBandwidth.Value));
                m_Instrument.SetAWGNMode(path, Mode.SelectedIndex);
                m_Instrument.SetAWGNSystemBandwidthRatio(path, Decimal.ToDouble(NoiseSystemRatio.Value));

                if (Mode.SelectedIndex == 0)
                    m_Instrument.SetAWGNCarriertoNoiseRatio(path, Decimal.ToDouble (CarrierNoiseRatio.Value));

                m_Instrument.SetAWGNState(path, AWGNState.Checked);
                m_Instrument.SetRFAmplitude(path, Decimal.ToDouble(RFLevel.Value));
                m_Instrument.SetRFFrequency(path, Decimal.ToDouble(RFFreq.Value));
                m_Instrument.SetOutputState(path, RFState.Checked);
            }
            catch (Exception ex)
            {
                String message;

                message = "Instrument Status Error: ";
                message += ex.Message;
                MessageBox.Show(message);
            }
            System.Windows.Forms.Cursor.Current = Cursors.Arrow;
            UseWaitCursor = false;
        }

    }
}